import os
import sys
import struct

if len(sys.argv)!=3:
	sys.exit("Usage: "+sys.argv[0]+" <infile.bin> <outfile.nb>")

hfi = open(sys.argv[1], "rb")
hfi.seek(0, os.SEEK_END)
bin_size = hfi.tell()
hfi.seek(0)

if hfi.read(7)!="B000FF\x0A":
	hfi.close()
	sys.exit("Not a B000FF image !")
img_addr, img_size = struct.unpack("<LL", hfi.read(8))

hfo = open(sys.argv[2], "wb")

while hfi.tell()<bin_size:
	addr, size, ck = struct.unpack("<LLL", hfi.read(12))
	if addr==0 and img_addr!=0:
		hfi.seek(size, os.SEEK_CUR)
	else:
		hfo.seek(addr-img_addr)
		hfo.write(hfi.read(size))
hfo.close()
hfi.close()
